import { PathsObjectSchema as PathsObjectSchema$1 } from '../processed/paths-object.js';

/**
 * Paths Object
 *
 * Holds the relative paths to the individual endpoints and their operations. The path is appended to the URL from the
 * Server Object in order to construct the full URL. The Paths Object MAY be empty, due to Access Control List (ACL)
 * constraints.
 *
 * @see https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.1.1.md#paths-object
 */
const PathsObjectSchema = PathsObjectSchema$1;

export { PathsObjectSchema };
