import { z } from 'zod';

const XScalarStabilityValues = {
    Deprecated: 'deprecated',
    Experimental: 'experimental',
    Stable: 'stable',
};
/**
 * An OpenAPI extension to indicate the stability of the operation
 *
 * @example
 * ```yaml
 * x-scalar-stability: deprecated
 * ```
 */
const XScalarStabilitySchema = z.object({
    'x-scalar-stability': z
        .enum(Object.values(XScalarStabilityValues))
        .optional()
        .catch(undefined),
});

export { XScalarStabilitySchema, XScalarStabilityValues };
