import { z } from 'zod';

const XTagGroupSchema = z.object({
    /**
     * The group name.
     */
    name: z.string(),
    /**
     * List of tags to include in this group.
     */
    tags: z.coerce.string().array().catch([]),
});
/**
 * x-tagGroups
 *
 * List of tags to include in this group.
 */
const XTagGroupsSchema = XTagGroupSchema.array().catch([]);

export { XTagGroupSchema, XTagGroupsSchema };
