import { s as UserSearchResult } from './narou-search-results-DWCJWTC5.cjs';
export { j as BigGenre, k as BigGenreNotation, B as BooleanNumber, m as BuntaiParam, D as DateParam, E as End, F as Fields, G as Genre, l as GenreNotation, q as GzipLevel, r as NarouSearchResult, N as NarouSearchResults, t as NovelType, o as NovelTypeParam, O as OptionalFields, g as Order, P as ParamsBase, a as ParamsBaseWithOrder, y as PickedNarouSearchResult, e as R18Fields, h as R18Site, i as R18SiteNotation, c as RankingHistoryParams, b as RankingParams, R as RankingType, S as SearchParams, d as SearchResultFieldNames, u as SearchResultFields, v as SearchResultOptionalFields, w as SearchResultR18Fields, n as StopParam, f as UserFields, p as UserOrder, U as UserSearchParams, x as UserSearchResultFields } from './narou-search-results-DWCJWTC5.cjs';
import { N as NarouNovel, S as SearchBuilder } from './narou-CatW_TC9.cjs';
export { D as DefaultSearchResultFields, a as NarouParams, b as NarouRankingResult, d as NovelSearchBuilderBase, R as RankingResult, c as SearchBuilderBase } from './narou-CatW_TC9.cjs';
export { default as NarouNovelJsonp } from './narou-jsonp.cjs';
import SearchBuilderR18 from './search-builder-r18.cjs';
export { DefaultR18SearchResultFields } from './search-builder-r18.cjs';
import RankingBuilder from './ranking.cjs';
import { RankingHistoryResult } from './ranking-history.cjs';
export { RankingHistoryRawResult, formatRankingHistory } from './ranking-history.cjs';
import UserSearchBuilder from './user-search.cjs';
import './util/type.cjs';

/**
 * 検索
 * @param {string} [word] - 検索ワード
 * @returns {SearchBuilder}
 */
declare function search(word?: string, api?: NarouNovel): SearchBuilder;
/**
 * 検索
 * @param {string} [word] - 検索ワード
 * @returns {SearchBuilder}
 */
declare function searchR18(word?: string, api?: NarouNovel): SearchBuilderR18;
/**
 * ユーザ検索
 */
declare function searchUser(word?: string, api?: NarouNovel): UserSearchBuilder<keyof UserSearchResult>;
declare function ranking(api?: NarouNovel): RankingBuilder;
declare function rankingHistory(ncode: string, api?: NarouNovel): Promise<RankingHistoryResult[]>;
declare const _default: {
    search: typeof search;
    searchR18: typeof searchR18;
    searchUser: typeof searchUser;
    ranking: typeof ranking;
    rankingHistory: typeof rankingHistory;
};

export { NarouNovel, RankingBuilder, RankingHistoryResult, SearchBuilder, SearchBuilderR18, UserSearchResult, _default as default, ranking, rankingHistory, search, searchR18, searchUser };
