import "./chunk-4ZP5YNWI.js";
import {
  formatRankingHistory
} from "./chunk-XAUB42TO.js";
import {
  RankingBuilder
} from "./chunk-4VC3246A.js";
import {
  SearchBuilderR18
} from "./chunk-WYSPGQ3S.js";
import {
  UserSearchBuilder
} from "./chunk-K22KVNAH.js";
import {
  NovelSearchBuilderBase,
  SearchBuilder,
  SearchBuilderBase
} from "./chunk-P7QOZBII.js";
import {
  BigGenre,
  BigGenreNotation,
  BooleanNumber,
  BuntaiParam,
  DateParam,
  Fields,
  Genre,
  GenreNotation,
  NovelTypeParam,
  OptionalFields,
  Order,
  R18Fields,
  R18Site,
  R18SiteNotation,
  RankingType,
  StopParam,
  UserFields,
  UserOrder
} from "./chunk-CDOBNSCL.js";
import {
  NarouNovelFetch
} from "./chunk-SNPBEVCY.js";
import "./chunk-NVMUSXA5.js";
import {
  NarouNovelJsonp
} from "./chunk-AZT2OXBZ.js";
import "./chunk-XVH2CU2Q.js";
import {
  NarouNovel
} from "./chunk-UN3W2CT3.js";
import {
  End,
  NarouSearchResults,
  NovelType
} from "./chunk-RITMMCZE.js";

// src/index.ts
var narouNovelFetch = new NarouNovelFetch();
function search(word = "", api = narouNovelFetch) {
  const builder = new SearchBuilder({}, api);
  if (word != "") builder.word(word);
  return builder;
}
function searchR18(word = "", api = narouNovelFetch) {
  const builder = new SearchBuilderR18({}, api);
  if (word != "") builder.word(word);
  return builder;
}
function searchUser(word = "", api = narouNovelFetch) {
  const builder = new UserSearchBuilder({}, api);
  if (word != "") builder.word(word);
  return builder;
}
function ranking(api = narouNovelFetch) {
  const builder = new RankingBuilder({}, api);
  return builder;
}
async function rankingHistory(ncode, api = narouNovelFetch) {
  const result = await api.executeRankingHistory({ ncode });
  if (Array.isArray(result)) {
    return result.map(formatRankingHistory);
  } else {
    throw new Error(result);
  }
}
var index_default = {
  search,
  searchR18,
  searchUser,
  ranking,
  rankingHistory
};
export {
  BigGenre,
  BigGenreNotation,
  BooleanNumber,
  BuntaiParam,
  DateParam,
  End,
  Fields,
  Genre,
  GenreNotation,
  NarouNovel,
  NarouNovelFetch,
  NarouNovelJsonp,
  NarouSearchResults,
  NovelSearchBuilderBase,
  NovelType,
  NovelTypeParam,
  OptionalFields,
  Order,
  R18Fields,
  R18Site,
  R18SiteNotation,
  RankingBuilder,
  RankingType,
  SearchBuilder,
  SearchBuilderBase,
  SearchBuilderR18,
  StopParam,
  UserFields,
  UserOrder,
  index_default as default,
  formatRankingHistory,
  ranking,
  rankingHistory,
  search,
  searchR18,
  searchUser
};
//# sourceMappingURL=index.js.map