import { d as NovelSearchBuilderBase } from './narou-fH9osIoh.js';
import { r as NarouSearchResult, d as SearchResultFieldNames, N as NarouSearchResults, h as R18Site, e as R18Fields, w as SearchResultR18Fields, O as OptionalFields, v as SearchResultOptionalFields } from './narou-search-results-D5yqPRZ7.js';
import './ranking-history.js';
import './util/type.js';

type DefaultR18SearchResultFields = keyof Omit<NarouSearchResult, "weekly_unique" | "noveltype" | "biggenre" | "genre" | "isr15" | "id">;
/**
 * 18禁API検索ヘルパー
 * @class SearchBuilderR18
 */
declare class SearchBuilderR18<T extends SearchResultFieldNames = DefaultR18SearchResultFields, TOpt extends keyof NarouSearchResult = never> extends NovelSearchBuilderBase<T | TOpt> {
    /**
     * なろう小説APIへの検索リクエストを実行する
     * @override
     * @returns {Promise<NarouSearchResults>} 検索結果
     */
    execute(): Promise<NarouSearchResults<NarouSearchResult, T | TOpt>>;
    r18Site(sites: R18Site | readonly R18Site[]): this;
    /**
     *
     * @return {SearchBuilder} this
     */
    xid(ids: number | readonly number[]): this;
    /**
     *
     * @return {SearchBuilder} this
     */
    fields<TFields extends R18Fields>(fields: TFields | readonly TFields[]): SearchBuilderR18<SearchResultR18Fields<R18Fields>>;
    opt<TFields extends OptionalFields>(option: TFields | readonly TFields[]): SearchBuilderR18<T, SearchResultOptionalFields<TFields>>;
}

export { type DefaultR18SearchResultFields, SearchBuilderR18 as default };
